unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComObj, ExtCtrls;

type
  TForm1 = class(TForm)
    btRun: TButton;
    btExit: TButton;
    tmRun: TTimer;
    btGetExcel1: TButton;
    btGetExcel2: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    tmGetExcelApp1: TTimer;
    tmGetExcelApp2: TTimer;
    procedure btRunClick(Sender: TObject);
    procedure btExitClick(Sender: TObject);
    procedure tmRunTimer(Sender: TObject);
    procedure btGetExcel1Click(Sender: TObject);
    procedure tmGetExcelApp1Timer(Sender: TObject);
    procedure tmGetExcelApp2Timer(Sender: TObject);
    procedure btGetExcel2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ExcelApp1,ExcelWorkBooks1, ExcelWorkSheets1: Variant;
    ExcelApp2,ExcelWorkBooks2, ExcelWorkSheets2: Variant;
  end;

function GetExcelSheet(workBookName, workSheetName: string; var ExcelSheet: Variant): Boolean;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btExitClick(Sender: TObject);
begin
//        ExcelApp1.WorkBooks.close;
//        ExcelApp1.Quit;
//        ExcelApp1:=Unassigned;

    ExcelApp1.ActiveWorkBook.Saved := True;
    ExcelApp1.WorkBooks.close;
    VarClear(ExcelWorkSheets1);
    VarClear(ExcelWorkBooks1);
    ExcelApp1.Quit;
    VarClear(ExcelApp1);

    ExcelApp2.ActiveWorkBook.Saved := True;
    ExcelApp2.WorkBooks.close;
    VarClear(ExcelWorkSheets2);
    VarClear(ExcelWorkBooks2);
    ExcelApp2.Quit;
    VarClear(ExcelApp2);


    Application.Terminate;
end;

procedure TForm1.btRunClick(Sender: TObject);
begin
    ExcelApp1:=CreateOleObject('Excel.Application');
    ExcelWorkBooks1:=ExcelApp1.WorkBooks.Add;
    ExcelWorkSheets1:=ExcelWorkBooks1.WorkSheets[1];
    ExcelApp1.Visible := True;
    ExcelWorkSheets1.Activate;
    ExcelWorkSheets1.Cells[1,1]:='ExcelApp1';
    ExcelWorkSheets1.Cells[2,1]:='ExcelWorkBooks1';
    ExcelWorkSheets1.Cells[3,1]:='ExcelWorkSheets1';

    ExcelApp2:=CreateOleObject('Excel.Application');
    ExcelWorkBooks2:=ExcelApp2.WorkBooks.Add;
    ExcelWorkSheets2:=ExcelWorkBooks2.WorkSheets[1];
    ExcelApp2.Visible := True;
    ExcelWorkSheets2.Activate;
    ExcelWorkSheets2.Cells[1,1]:='ExcelApp2';
    ExcelWorkSheets2.Cells[2,1]:='ExcelWorkBooks2';
    ExcelWorkSheets2.Cells[3,1]:='ExcelWorkSheets2';

    btRun.Enabled:=False;
    btExit.Enabled:=True;
    btGetExcel1.Enabled:=True;
    btGetExcel2.Enabled:=True;
    tmRun.Enabled:=true;
end;

procedure TForm1.tmRunTimer(Sender: TObject);
begin
    tmRun.Enabled:=False;
    ExcelWorkSheets1.Cells[4,1]:=TimeToStr(Now);
    ExcelWorkSheets2.Cells[4,1]:=TimeToStr(Now);
    tmRun.Enabled:=True;
end;

procedure TForm1.btGetExcel1Click(Sender: TObject);
var
    exSheet:    Variant;
begin
    if GetExcelSheet('Book1', 'Sheet1', exSheet) then begin
        Memo1.Clear;
        Memo1.Lines.Add(exSheet.Cells[1,1]);
        Memo1.Lines.Add(exSheet.Cells[2,1]);
        Memo1.Lines.Add(exSheet.Cells[3,1]);
        Memo1.Lines.Add(exSheet.Cells[4,1]);
        tmGetExcelApp1.Enabled:=True;
        btGetExcel1.Enabled:=False;
    end;
end;

procedure TForm1.btGetExcel2Click(Sender: TObject);
var
    exSheet:    Variant;
begin
    if GetExcelSheet('Book2', 'Sheet1', exSheet) then begin
        Memo2.Clear;
        Memo2.Lines.Add(exSheet.Cells[1,1]);
        Memo2.Lines.Add(exSheet.Cells[2,1]);
        Memo2.Lines.Add(exSheet.Cells[3,1]);
        Memo2.Lines.Add(exSheet.Cells[4,1]);
        tmGetExcelApp2.Enabled:=True;
        btGetExcel2.Enabled:=False;
    end else begin
        Showmessage('Error here! This is read from BOOK1.Sheet1, not BOOK2...How Can I read BOOK2');
    end;
end;

procedure TForm1.tmGetExcelApp1Timer(Sender: TObject);
var
    exApp, exWorkBook, exSheet:    Variant;
begin
    tmGetExcelApp1.Enabled:=False;
    exApp:=GetActiveOleObject('Excel.Application');
    exWorkBook:=exApp.WorkBooks[1];
    exSheet:=exApp.WorkBooks[1].WorkSheets[1];
    Memo1.Lines.Add(exSheet.Cells[4,1]);
    tmGetExcelApp1.Enabled:=True;
end;

procedure TForm1.tmGetExcelApp2Timer(Sender: TObject);
var
    exApp, exWorkBook, exSheet:    Variant;
begin
    tmGetExcelApp2.Enabled:=False;
    exApp:=GetActiveOleObject('Excel.Application');
    exWorkBook:=exApp.WorkBooks[1];
    exSheet:=exApp.WorkBooks[1].WorkSheets[1];
    Memo2.Lines.Add(exSheet.Cells[4,1]);
    tmGetExcelApp2.Enabled:=True;
end;

function GetExcelSheet(workBookName, workSheetName: string; var ExcelSheet: Variant): Boolean;
var
    ExcelApp:       Variant;
    ExcelWorkBook:  Variant;

    s: string;
    i,j : integer;
    test: integer;
begin
  Result:=False;
  try
    test:=0;
    ExcelApp:=GetActiveOleObject('Excel.Application');
    for i:=1 to ExcelApp.WorkBooks.count do begin
        s:=ExcelApp.WorkBooks[i].Name;
        if s=workBookName then begin
            for j:=1 to ExcelApp.WorkBooks[i].WorkSheets.Count do begin
                s:=ExcelApp.WorkBooks[i].WorkSheets[j].Name;
                if s=workSheetName then begin
                    ExcelWorkBook:=ExcelApp.WorkBooks[i];
                    ExcelSheet:=ExcelApp.WorkBooks[i].WorkSheets[j];
                    test:=test+1;
                end;
            end;
        end;
    end;

    if test=0 then begin
        Showmessage('ExcelConnect: Excel Sheets did not exist: '+workBookName+'.'+workSheetName);
        exit;
    end else if test>1 then begin
        Showmessage('ExcelConnect: Excel Sheets too many error: '+workBookName+'.'+workSheetName);
        exit;
    end;
    Result:=true;
  except
    on EOleSysError do begin
        Showmessage('ExcelConnect: Execl Share Memory is not running.');
        exit;
    end;
  end;
end;

end.
